#include <stdio.h>
#include <stdlib.h>

#include "tree.h"

int tree_insert(Tree *tree, int data) {
  Node *new_node = malloc(sizeof(Node));
  new_node->data = data;
  new_node->left = NULL;
  new_node->right = NULL;

  // If the tree is empty
  if (tree->root == NULL) {
    tree->root = new_node;
    return 0; // Early return
  }

  // If the tree is non-empty
  Node *cursor = tree->root;

  // An iterative (non-recursive approach) to tree insertion
  // While we look for a place to put our new node
  while (1) {
    // If larger than data
    if (new_node->data > cursor->data) {
      // If there is a child to the right
      if (cursor->right != NULL)
        cursor = cursor->right;
      else {
        cursor->right = new_node; // Put our node here
        break;                    // Break the outer while loop
      }
    }

    // If less-or-equal than our data
    if (new_node->data <= cursor->data) {
      // If there is a child to the left
      if (cursor->left != NULL)
        cursor = cursor->left;
      else {
        cursor->left = new_node; // Put our node here
        break;                   // Break the outer while loop
      }
    }
  }
}

int tree_remove(Tree *tree, int data) { return 1; }

int tree_clear(Tree *tree) { return 1; }

int tree_size(Tree *tree) {
  if (tree->root == NULL) {
    return 0;
  }

  int size = 0;
  Node *current = tree->root;
  while (current != NULL) {
    size++;
    if (current->left != NULL) {
      current = current->left;
    } else if (current->right != NULL) {
      current = current->right;
    } else {
      current = NULL;
    }
  }
  return size;
}
